def process_word(word):
        remove = '.!?,"\'()*_:;0123456789'
        word = word.strip()
        for character in remove:
                word = word.replace(character," ")

        word = word.lower()
        return word

def process_line(line):
        line = line.strip()
        line = line.replace("-"," ")
        words = line.split()
        processed_words =  []
        for word in words:
                processed_words.append(process_word(word))
        return processed_words

def process_file(path):
        with open(path) as file:
                words = []
                data = file.readlines()

                for line in data:
                        words = words + process_line(line)
        return words 

def find_unique(words):
        unique_words = []
        for word in words:
                if word not in unique_words:
                        unique_words.append(word)
        return unique_words

def find_frequency(words):
        freq_dict = {}
        for word in words:
                if word in freq_dict:
                        freq_dict[word]+=1
                else:
                        freq_dict[word]=1
        return freq_dict

def remove_stop(words,stop):
        non_stop_words = []
        for word in words:
                if word not in stop:
                        non_stop_words.append(word)

        return non_stop_words

def most_common(freq_dict,n):
        freq_list = []
        for item in list(freq_dict.items()):
                val = (item[1],item[0])
                freq_list.append(val)
        freq_list.sort(reverse=True)
        print(f"{'Word':<12}{'Count':>4}")
        print(("-"*16))
        for index in range(0,n):
                count = freq_list[index][0]
                word = freq_list[index][1]
                print(f"{word: <12}{count: >4}")

def count_by_length(words):
        count_dict = {}
        for word in words:
                length = len(word)
                if length in count_dict:
                        count_dict[length]+=1
                else:
                        count_dict[length]=1
        count_list = []
        for item in list(count_dict.items()):
                count_list.append(item)

        count_list.sort(reverse=True)
        print(f"{'Length':<12}{'Count':>4}")
        print(("-"*16))
        for item in count_list:
                print(f"{item[0]: <12}{item[1]: >4}")

def count_by_first(words):
        count_dict = {}
        for word in words:
                char= word[0]
                if char in count_dict:
                        count_dict[char]+=1
                else:
                        count_dict[char]=1
        count_list = []
        for item in list(count_dict.items()):
                count_list.append(item)

        count_list.sort(reverse=True)
        print(f"{'Letter':<12}{'Count':>4}")
        print(("-"*16))
        for item in count_list:
                print(f"{item[0]: <12}{item[1]: >4}") 